# -*- coding: utf-8 -*-
#
# This class was auto-generated from the API references found at
# https://apireference.connect.worldline-solutions.com/
#
from typing import Optional

from worldline.connect.sdk.domain.data_object import DataObject


class CreateHostedMandateManagementResponse(DataObject):

    __returnmac: Optional[str] = None
    __hosted_mandate_management_id: Optional[str] = None
    __partial_redirect_url: Optional[str] = None

    @property
    def returnmac(self) -> Optional[str]:
        """
        | When the customer is returned to your site we will append this property and value to the query-string. You should store this data, so you can identify the returning customer.

        Type: str
        """
        return self.__returnmac

    @returnmac.setter
    def returnmac(self, value: Optional[str]) -> None:
        self.__returnmac = value

    @property
    def hosted_mandate_management_id(self) -> Optional[str]:
        """
        | This is the ID under which the data for this mandate management can be retrieved.

        Type: str
        """
        return self.__hosted_mandate_management_id

    @hosted_mandate_management_id.setter
    def hosted_mandate_management_id(self, value: Optional[str]) -> None:
        self.__hosted_mandate_management_id = value

    @property
    def partial_redirect_url(self) -> Optional[str]:
        """
        | The partial URL as generated by our system. You will need to add the protocol and the relevant subdomain to this URL, before redirecting your customer to this URL. A special 'payment' subdomain will always work so you can always add 'https://payment.' at the beginning of this response value to view your hosted mandate management pages.

        Type: str
        """
        return self.__partial_redirect_url

    @partial_redirect_url.setter
    def partial_redirect_url(self, value: Optional[str]) -> None:
        self.__partial_redirect_url = value

    def to_dictionary(self) -> dict:
        dictionary = super(CreateHostedMandateManagementResponse, self).to_dictionary()
        if self.returnmac is not None:
            dictionary['RETURNMAC'] = self.returnmac
        if self.hosted_mandate_management_id is not None:
            dictionary['hostedMandateManagementId'] = self.hosted_mandate_management_id
        if self.partial_redirect_url is not None:
            dictionary['partialRedirectUrl'] = self.partial_redirect_url
        return dictionary

    def from_dictionary(self, dictionary: dict) -> 'CreateHostedMandateManagementResponse':
        super(CreateHostedMandateManagementResponse, self).from_dictionary(dictionary)
        if 'RETURNMAC' in dictionary:
            self.returnmac = dictionary['RETURNMAC']
        if 'hostedMandateManagementId' in dictionary:
            self.hosted_mandate_management_id = dictionary['hostedMandateManagementId']
        if 'partialRedirectUrl' in dictionary:
            self.partial_redirect_url = dictionary['partialRedirectUrl']
        return self
